Index: c/src/lib/libbsp/bfin/TLL6527M/Makefile.am
===================================================================
--- c/src/lib/libbsp/bfin/TLL6527M/Makefile.am	(revision 271b8a61c10c004178104c52cbc9e4e9ebd17ab3)
+++ c/src/lib/libbsp/bfin/TLL6527M/Makefile.am	(revision 45d06591f12c108ab27207c464ce46f0d0f26980)
@@ -30,5 +30,5 @@
 librtemsbsp_a_SOURCES += ../../../../../../bsps/bfin/TLL6527M/start/interrupt.c
 
-
+include $(srcdir)/../../../../../../bsps/shared/irq-default-sources.am
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/bfin/shared/shared-sources.am
Index: c/src/lib/libbsp/bfin/bf537Stamp/Makefile.am
===================================================================
--- c/src/lib/libbsp/bfin/bf537Stamp/Makefile.am	(revision 271b8a61c10c004178104c52cbc9e4e9ebd17ab3)
+++ c/src/lib/libbsp/bfin/bf537Stamp/Makefile.am	(revision 45d06591f12c108ab27207c464ce46f0d0f26980)
@@ -36,4 +36,5 @@
 endif
 
+include $(srcdir)/../../../../../../bsps/shared/irq-default-sources.am
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/bfin/shared/shared-sources.am
Index: c/src/lib/libbsp/bfin/eZKit533/Makefile.am
===================================================================
--- c/src/lib/libbsp/bfin/eZKit533/Makefile.am	(revision 271b8a61c10c004178104c52cbc9e4e9ebd17ab3)
+++ c/src/lib/libbsp/bfin/eZKit533/Makefile.am	(revision 45d06591f12c108ab27207c464ce46f0d0f26980)
@@ -31,5 +31,5 @@
 librtemsbsp_a_SOURCES += ../../../../../../bsps/bfin/shared/interrupt.c
 
-
+include $(srcdir)/../../../../../../bsps/shared/irq-default-sources.am
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/bfin/shared/shared-sources.am
Index: c/src/lib/libbsp/lm32/lm32_evr/Makefile.am
===================================================================
--- c/src/lib/libbsp/lm32/lm32_evr/Makefile.am	(revision 271b8a61c10c004178104c52cbc9e4e9ebd17ab3)
+++ c/src/lib/libbsp/lm32/lm32_evr/Makefile.am	(revision 45d06591f12c108ab27207c464ce46f0d0f26980)
@@ -43,5 +43,5 @@
 endif
 
-
+include $(srcdir)/../../../../../../bsps/shared/irq-default-sources.am
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/lm32/lm32_evr/headers.am
Index: c/src/lib/libbsp/lm32/milkymist/Makefile.am
===================================================================
--- c/src/lib/libbsp/lm32/milkymist/Makefile.am	(revision 271b8a61c10c004178104c52cbc9e4e9ebd17ab3)
+++ c/src/lib/libbsp/lm32/milkymist/Makefile.am	(revision 45d06591f12c108ab27207c464ce46f0d0f26980)
@@ -90,4 +90,5 @@
 endif
 
+include $(srcdir)/../../../../../../bsps/shared/irq-default-sources.am
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/lm32/milkymist/headers.am
Index: c/src/lib/libbsp/m68k/av5282/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/av5282/Makefile.am	(revision 271b8a61c10c004178104c52cbc9e4e9ebd17ab3)
+++ c/src/lib/libbsp/m68k/av5282/Makefile.am	(revision 45d06591f12c108ab27207c464ce46f0d0f26980)
@@ -42,4 +42,5 @@
 librtemsbsp_a_SOURCES += ../../../../../../bsps/m68k/shared/memProbe.c
 
+include $(srcdir)/../../../../../../bsps/shared/irq-default-sources.am
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/m68k/av5282/headers.am
Index: c/src/lib/libbsp/m68k/csb360/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/csb360/Makefile.am	(revision 271b8a61c10c004178104c52cbc9e4e9ebd17ab3)
+++ c/src/lib/libbsp/m68k/csb360/Makefile.am	(revision 45d06591f12c108ab27207c464ce46f0d0f26980)
@@ -38,4 +38,5 @@
 librtemsbsp_a_SOURCES += ../../../../../../bsps/m68k/csb360/start/idle-mcf5272.c
 
+include $(srcdir)/../../../../../../bsps/shared/irq-default-sources.am
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/m68k/csb360/headers.am
Index: c/src/lib/libbsp/m68k/gen68340/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/gen68340/Makefile.am	(revision 271b8a61c10c004178104c52cbc9e4e9ebd17ab3)
+++ c/src/lib/libbsp/m68k/gen68340/Makefile.am	(revision 45d06591f12c108ab27207c464ce46f0d0f26980)
@@ -41,4 +41,5 @@
 librtemsbsp_a_SOURCES += ../../../../../../bsps/m68k/shared/memProbe.c
 
+include $(srcdir)/../../../../../../bsps/shared/irq-default-sources.am
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/m68k/gen68340/headers.am
Index: c/src/lib/libbsp/m68k/gen68360/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/gen68360/Makefile.am	(revision 271b8a61c10c004178104c52cbc9e4e9ebd17ab3)
+++ c/src/lib/libbsp/m68k/gen68360/Makefile.am	(revision 45d06591f12c108ab27207c464ce46f0d0f26980)
@@ -50,4 +50,5 @@
 endif
 
+include $(srcdir)/../../../../../../bsps/shared/irq-default-sources.am
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/m68k/gen68360/headers.am
Index: c/src/lib/libbsp/m68k/mcf5206elite/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mcf5206elite/Makefile.am	(revision 271b8a61c10c004178104c52cbc9e4e9ebd17ab3)
+++ c/src/lib/libbsp/m68k/mcf5206elite/Makefile.am	(revision 45d06591f12c108ab27207c464ce46f0d0f26980)
@@ -49,4 +49,5 @@
 librtemsbsp_a_SOURCES += ../../../../../../bsps/m68k/mcf5206elite/dev/timerisr.S
 
+include $(srcdir)/../../../../../../bsps/shared/irq-default-sources.am
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/m68k/mcf5206elite/headers.am
Index: c/src/lib/libbsp/m68k/mcf52235/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mcf52235/Makefile.am	(revision 271b8a61c10c004178104c52cbc9e4e9ebd17ab3)
+++ c/src/lib/libbsp/m68k/mcf52235/Makefile.am	(revision 45d06591f12c108ab27207c464ce46f0d0f26980)
@@ -42,4 +42,5 @@
 librtemsbsp_a_SOURCES += ../../../../../../bsps/m68k/shared/memProbe.c
 
+include $(srcdir)/../../../../../../bsps/shared/irq-default-sources.am
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/m68k/mcf52235/headers.am
Index: c/src/lib/libbsp/m68k/mcf5225x/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mcf5225x/Makefile.am	(revision 271b8a61c10c004178104c52cbc9e4e9ebd17ab3)
+++ c/src/lib/libbsp/m68k/mcf5225x/Makefile.am	(revision 45d06591f12c108ab27207c464ce46f0d0f26980)
@@ -33,4 +33,5 @@
 librtemsbsp_a_SOURCES += ../../../../../../bsps/m68k/shared/memProbe.c
 
+include $(srcdir)/../../../../../../bsps/shared/irq-default-sources.am
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/m68k/mcf5225x/headers.am
Index: c/src/lib/libbsp/m68k/mcf5235/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mcf5235/Makefile.am	(revision 271b8a61c10c004178104c52cbc9e4e9ebd17ab3)
+++ c/src/lib/libbsp/m68k/mcf5235/Makefile.am	(revision 45d06591f12c108ab27207c464ce46f0d0f26980)
@@ -46,4 +46,5 @@
 librtemsbsp_a_SOURCES += ../../../../../../bsps/m68k/shared/memProbe.c
 
+include $(srcdir)/../../../../../../bsps/shared/irq-default-sources.am
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/m68k/mcf5235/headers.am
Index: c/src/lib/libbsp/m68k/mcf5329/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mcf5329/Makefile.am	(revision 271b8a61c10c004178104c52cbc9e4e9ebd17ab3)
+++ c/src/lib/libbsp/m68k/mcf5329/Makefile.am	(revision 45d06591f12c108ab27207c464ce46f0d0f26980)
@@ -44,4 +44,5 @@
 librtemsbsp_a_SOURCES += ../../../../../../bsps/m68k/shared/memProbe.c
 
+include $(srcdir)/../../../../../../bsps/shared/irq-default-sources.am
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/m68k/mcf5329/headers.am
Index: c/src/lib/libbsp/m68k/mrm332/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mrm332/Makefile.am	(revision 271b8a61c10c004178104c52cbc9e4e9ebd17ab3)
+++ c/src/lib/libbsp/m68k/mrm332/Makefile.am	(revision 45d06591f12c108ab27207c464ce46f0d0f26980)
@@ -41,4 +41,5 @@
 librtemsbsp_a_SOURCES += ../../../../../../bsps/m68k/shared/memProbe.c
 
+include $(srcdir)/../../../../../../bsps/shared/irq-default-sources.am
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/m68k/mrm332/headers.am
Index: c/src/lib/libbsp/m68k/mvme147/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mvme147/Makefile.am	(revision 271b8a61c10c004178104c52cbc9e4e9ebd17ab3)
+++ c/src/lib/libbsp/m68k/mvme147/Makefile.am	(revision 45d06591f12c108ab27207c464ce46f0d0f26980)
@@ -41,5 +41,5 @@
 librtemsbsp_a_SOURCES += ../../../../../../bsps/m68k/shared/memProbe.c
 
-
+include $(srcdir)/../../../../../../bsps/shared/irq-default-sources.am
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/m68k/mvme147/headers.am
Index: c/src/lib/libbsp/m68k/mvme147s/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mvme147s/Makefile.am	(revision 271b8a61c10c004178104c52cbc9e4e9ebd17ab3)
+++ c/src/lib/libbsp/m68k/mvme147s/Makefile.am	(revision 45d06591f12c108ab27207c464ce46f0d0f26980)
@@ -50,5 +50,5 @@
 librtemsbsp_a_SOURCES += ../../../../../../bsps/m68k/shared/memProbe.c
 
-
+include $(srcdir)/../../../../../../bsps/shared/irq-default-sources.am
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/m68k/mvme147s/headers.am
Index: c/src/lib/libbsp/m68k/mvme162/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mvme162/Makefile.am	(revision 271b8a61c10c004178104c52cbc9e4e9ebd17ab3)
+++ c/src/lib/libbsp/m68k/mvme162/Makefile.am	(revision 45d06591f12c108ab27207c464ce46f0d0f26980)
@@ -51,5 +51,5 @@
 endif
 
-
+include $(srcdir)/../../../../../../bsps/shared/irq-default-sources.am
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/m68k/mvme162/headers.am
Index: c/src/lib/libbsp/m68k/mvme167/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mvme167/Makefile.am	(revision 271b8a61c10c004178104c52cbc9e4e9ebd17ab3)
+++ c/src/lib/libbsp/m68k/mvme167/Makefile.am	(revision 45d06591f12c108ab27207c464ce46f0d0f26980)
@@ -43,5 +43,5 @@
 librtemsbsp_a_SOURCES += ../../../../../../bsps/m68k/shared/memProbe.c
 
-
+include $(srcdir)/../../../../../../bsps/shared/irq-default-sources.am
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/m68k/shared/fpsp-sources.am
Index: c/src/lib/libbsp/m68k/uC5282/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/uC5282/Makefile.am	(revision 271b8a61c10c004178104c52cbc9e4e9ebd17ab3)
+++ c/src/lib/libbsp/m68k/uC5282/Makefile.am	(revision 45d06591f12c108ab27207c464ce46f0d0f26980)
@@ -42,4 +42,5 @@
 librtemsbsp_a_SOURCES += ../../../../../../bsps/m68k/shared/memProbe.c
 
+include $(srcdir)/../../../../../../bsps/shared/irq-default-sources.am
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/m68k/uC5282/headers.am
Index: c/src/lib/libbsp/moxie/moxiesim/Makefile.am
===================================================================
--- c/src/lib/libbsp/moxie/moxiesim/Makefile.am	(revision 271b8a61c10c004178104c52cbc9e4e9ebd17ab3)
+++ c/src/lib/libbsp/moxie/moxiesim/Makefile.am	(revision 45d06591f12c108ab27207c464ce46f0d0f26980)
@@ -40,5 +40,5 @@
 librtemsbsp_a_SOURCES += ../../../../../../bsps/shared/cache/nocache.c
 
-
+include $(srcdir)/../../../../../../bsps/shared/irq-default-sources.am
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/moxie/moxiesim/headers.am
Index: c/src/lib/libbsp/nios2/nios2_iss/Makefile.am
===================================================================
--- c/src/lib/libbsp/nios2/nios2_iss/Makefile.am	(revision 271b8a61c10c004178104c52cbc9e4e9ebd17ab3)
+++ c/src/lib/libbsp/nios2/nios2_iss/Makefile.am	(revision 45d06591f12c108ab27207c464ce46f0d0f26980)
@@ -39,4 +39,5 @@
 librtemsbsp_a_SOURCES += ../../../../../../bsps/shared/cache/nocache.c
 
+include $(srcdir)/../../../../../../bsps/shared/irq-default-sources.am
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/nios2/nios2_iss/headers.am
Index: c/src/lib/libbsp/no_cpu/no_bsp/Makefile.am
===================================================================
--- c/src/lib/libbsp/no_cpu/no_bsp/Makefile.am	(revision 271b8a61c10c004178104c52cbc9e4e9ebd17ab3)
+++ c/src/lib/libbsp/no_cpu/no_bsp/Makefile.am	(revision 45d06591f12c108ab27207c464ce46f0d0f26980)
@@ -34,5 +34,5 @@
 librtemsbsp_a_SOURCES += ../../../../../../bsps/no_cpu/no_bsp/mpci/mpisr.c
 
-
+include $(srcdir)/../../../../../../bsps/shared/irq-default-sources.am
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/no_cpu/no_bsp/headers.am
Index: c/src/lib/libbsp/powerpc/beatnik/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/beatnik/Makefile.am	(revision 271b8a61c10c004178104c52cbc9e4e9ebd17ab3)
+++ c/src/lib/libbsp/powerpc/beatnik/Makefile.am	(revision 45d06591f12c108ab27207c464ce46f0d0f26980)
@@ -109,5 +109,5 @@
 librtemsbsp_a_SOURCES += ../../../../../../bsps/powerpc/shared/irq/ppc-irq-legacy.c
 
-
+include $(srcdir)/../../../../../../bsps/shared/irq-default-sources.am
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/powerpc/shared/shared-sources.am
Index: c/src/lib/libbsp/powerpc/haleakala/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/haleakala/Makefile.am	(revision 271b8a61c10c004178104c52cbc9e4e9ebd17ab3)
+++ c/src/lib/libbsp/powerpc/haleakala/Makefile.am	(revision 45d06591f12c108ab27207c464ce46f0d0f26980)
@@ -46,4 +46,5 @@
 librtemsbsp_a_SOURCES += ../../../../../../bsps/powerpc/shared/irq/ppc-irq-legacy.c
 
+include $(srcdir)/../../../../../../bsps/shared/irq-default-sources.am
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/powerpc/shared/shared-sources.am
Index: c/src/lib/libbsp/powerpc/motorola_powerpc/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/motorola_powerpc/Makefile.am	(revision 271b8a61c10c004178104c52cbc9e4e9ebd17ab3)
+++ c/src/lib/libbsp/powerpc/motorola_powerpc/Makefile.am	(revision 45d06591f12c108ab27207c464ce46f0d0f26980)
@@ -95,4 +95,5 @@
 librtemsbsp_a_SOURCES += ../../../../../../bsps/powerpc/shared/irq/ppc-irq-legacy.c
 
+include $(srcdir)/../../../../../../bsps/shared/irq-default-sources.am
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(top_srcdir)/../../../../automake/subdirs.am
Index: c/src/lib/libbsp/powerpc/mvme3100/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/mvme3100/Makefile.am	(revision 271b8a61c10c004178104c52cbc9e4e9ebd17ab3)
+++ c/src/lib/libbsp/powerpc/mvme3100/Makefile.am	(revision 45d06591f12c108ab27207c464ce46f0d0f26980)
@@ -91,5 +91,5 @@
 librtemsbsp_a_SOURCES += ../../../../../../bsps/powerpc/shared/mmu/e500-mmu.c
 
-
+include $(srcdir)/../../../../../../bsps/shared/irq-default-sources.am
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/powerpc/shared/shared-sources.am
Index: c/src/lib/libbsp/powerpc/mvme5500/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/mvme5500/Makefile.am	(revision 271b8a61c10c004178104c52cbc9e4e9ebd17ab3)
+++ c/src/lib/libbsp/powerpc/mvme5500/Makefile.am	(revision 45d06591f12c108ab27207c464ce46f0d0f26980)
@@ -84,4 +84,5 @@
 librtemsbsp_a_SOURCES += ../../../../../../bsps/powerpc/shared/irq/ppc-irq-legacy.c
 
+include $(srcdir)/../../../../../../bsps/shared/irq-default-sources.am
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/powerpc/shared/shared-sources.am
Index: c/src/lib/libbsp/powerpc/ss555/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/ss555/Makefile.am	(revision 271b8a61c10c004178104c52cbc9e4e9ebd17ab3)
+++ c/src/lib/libbsp/powerpc/ss555/Makefile.am	(revision 45d06591f12c108ab27207c464ce46f0d0f26980)
@@ -46,4 +46,12 @@
 librtemsbsp_a_SOURCES += ../../../../../../bsps/powerpc/ss555/start/vectors.S
 
+librtemsbsp_a_SOURCES += ../../../../../../bsps/shared/irq/irq-default.c
+librtemsbsp_a_SOURCES += ../../../../../../bsps/shared/irq/irq-default-handler.c
+librtemsbsp_a_SOURCES += ../../../../../../bsps/shared/irq/irq-generic.c
+librtemsbsp_a_SOURCES += ../../../../../../bsps/shared/irq/irq-info.c
+librtemsbsp_a_SOURCES += ../../../../../../bsps/shared/irq/irq-lock.c
+librtemsbsp_a_SOURCES += ../../../../../../bsps/shared/irq/irq-server.c
+librtemsbsp_a_SOURCES += ../../../../../../bsps/shared/irq/irq-shell.c
+
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/powerpc/shared/shared-sources.am
Index: c/src/lib/libbsp/powerpc/virtex4/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/virtex4/Makefile.am	(revision 271b8a61c10c004178104c52cbc9e4e9ebd17ab3)
+++ c/src/lib/libbsp/powerpc/virtex4/Makefile.am	(revision 45d06591f12c108ab27207c464ce46f0d0f26980)
@@ -50,5 +50,5 @@
 librtemsbsp_a_SOURCES += ../../../../../../bsps/powerpc/shared/btimer/btimer-ppc-dec.c
 
-
+include $(srcdir)/../../../../../../bsps/shared/irq-default-sources.am
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/powerpc/shared/shared-sources.am
Index: c/src/lib/libbsp/powerpc/virtex5/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/virtex5/Makefile.am	(revision 271b8a61c10c004178104c52cbc9e4e9ebd17ab3)
+++ c/src/lib/libbsp/powerpc/virtex5/Makefile.am	(revision 45d06591f12c108ab27207c464ce46f0d0f26980)
@@ -52,5 +52,5 @@
 librtemsbsp_a_SOURCES += ../../../../../../bsps/powerpc/shared/btimer/btimer-ppc-dec.c
 
-
+include $(srcdir)/../../../../../../bsps/shared/irq-default-sources.am
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/powerpc/shared/shared-sources.am
Index: c/src/lib/libbsp/sh/gensh1/Makefile.am
===================================================================
--- c/src/lib/libbsp/sh/gensh1/Makefile.am	(revision 271b8a61c10c004178104c52cbc9e4e9ebd17ab3)
+++ c/src/lib/libbsp/sh/gensh1/Makefile.am	(revision 45d06591f12c108ab27207c464ce46f0d0f26980)
@@ -41,5 +41,5 @@
 librtemsbsp_a_SOURCES += ../../../../../../bsps/shared/cache/nocache.c
 
-
+include $(srcdir)/../../../../../../bsps/shared/irq-default-sources.am
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/sh/gensh1/headers.am
Index: c/src/lib/libbsp/sh/gensh2/Makefile.am
===================================================================
--- c/src/lib/libbsp/sh/gensh2/Makefile.am	(revision 271b8a61c10c004178104c52cbc9e4e9ebd17ab3)
+++ c/src/lib/libbsp/sh/gensh2/Makefile.am	(revision 45d06591f12c108ab27207c464ce46f0d0f26980)
@@ -45,4 +45,5 @@
 librtemsbsp_a_SOURCES += ../../../../../../bsps/shared/cache/nocache.c
 
+include $(srcdir)/../../../../../../bsps/shared/irq-default-sources.am
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/sh/gensh2/headers.am
Index: c/src/lib/libbsp/sh/gensh4/Makefile.am
===================================================================
--- c/src/lib/libbsp/sh/gensh4/Makefile.am	(revision 271b8a61c10c004178104c52cbc9e4e9ebd17ab3)
+++ c/src/lib/libbsp/sh/gensh4/Makefile.am	(revision 45d06591f12c108ab27207c464ce46f0d0f26980)
@@ -40,5 +40,5 @@
 librtemsbsp_a_SOURCES += ../../../../../../bsps/shared/cache/nocache.c
 
-
+include $(srcdir)/../../../../../../bsps/shared/irq-default-sources.am
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/sh/gensh4/headers.am
Index: c/src/lib/libbsp/sh/shsim/Makefile.am
===================================================================
--- c/src/lib/libbsp/sh/shsim/Makefile.am	(revision 271b8a61c10c004178104c52cbc9e4e9ebd17ab3)
+++ c/src/lib/libbsp/sh/shsim/Makefile.am	(revision 45d06591f12c108ab27207c464ce46f0d0f26980)
@@ -44,4 +44,5 @@
 librtemsbsp_a_SOURCES += ../../../../../../bsps/shared/cache/nocache.c
 
+include $(srcdir)/../../../../../../bsps/shared/irq-default-sources.am
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/sh/shsim/headers.am
Index: c/src/lib/libbsp/sparc64/niagara/Makefile.am
===================================================================
--- c/src/lib/libbsp/sparc64/niagara/Makefile.am	(revision 271b8a61c10c004178104c52cbc9e4e9ebd17ab3)
+++ c/src/lib/libbsp/sparc64/niagara/Makefile.am	(revision 45d06591f12c108ab27207c464ce46f0d0f26980)
@@ -46,4 +46,5 @@
 librtemsbsp_a_SOURCES += ../../../../../../bsps/shared/cache/nocache.c
 
+include $(srcdir)/../../../../../../bsps/shared/irq-default-sources.am
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/sparc64/niagara/headers.am
Index: c/src/lib/libbsp/sparc64/usiii/Makefile.am
===================================================================
--- c/src/lib/libbsp/sparc64/usiii/Makefile.am	(revision 271b8a61c10c004178104c52cbc9e4e9ebd17ab3)
+++ c/src/lib/libbsp/sparc64/usiii/Makefile.am	(revision 45d06591f12c108ab27207c464ce46f0d0f26980)
@@ -57,4 +57,5 @@
 librtemsbsp_a_SOURCES += ../../../../../../bsps/shared/cache/nocache.c
 
+include $(srcdir)/../../../../../../bsps/shared/irq-default-sources.am
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/sparc64/usiii/headers.am
Index: c/src/lib/libbsp/v850/gdbv850sim/Makefile.am
===================================================================
--- c/src/lib/libbsp/v850/gdbv850sim/Makefile.am	(revision 271b8a61c10c004178104c52cbc9e4e9ebd17ab3)
+++ c/src/lib/libbsp/v850/gdbv850sim/Makefile.am	(revision 45d06591f12c108ab27207c464ce46f0d0f26980)
@@ -37,4 +37,5 @@
 project_lib_LIBRARIES = librtemsbsp.a
 
+include $(srcdir)/../../../../../../bsps/shared/irq-default-sources.am
 include $(srcdir)/../../../../../../bsps/shared/shared-sources.am
 include $(srcdir)/../../../../../../bsps/v850/gdbv850sim/headers.am