Index: testsuites/mptests/mp01/node1/Makefile.am
===================================================================
--- testsuites/mptests/mp01/node1/Makefile.am	(revision 2cd2ed3288e8ac35d69ec6f6140ad431b135109c)
+++ testsuites/mptests/mp01/node1/Makefile.am	(revision 48e02af9ca52c19fdc7300f8e3c6ad05a6952d94)
@@ -12,5 +12,5 @@
 AM_CPPFLAGS += -I$(top_srcdir)/../support/include
 
-LINK_OBJS = 
+LINK_OBJS = $(mp01_node1_OBJECTS)
 LINK_LIBS = $(mp01_node1_LDLIBS)
 
Index: testsuites/mptests/mp01/node2/Makefile.am
===================================================================
--- testsuites/mptests/mp01/node2/Makefile.am	(revision 2cd2ed3288e8ac35d69ec6f6140ad431b135109c)
+++ testsuites/mptests/mp01/node2/Makefile.am	(revision 48e02af9ca52c19fdc7300f8e3c6ad05a6952d94)
@@ -13,5 +13,5 @@
 AM_CPPFLAGS += -I$(top_srcdir)/../support/include
 
-LINK_OBJS = 
+LINK_OBJS = $(mp01_node2_OBJECTS)
 LINK_LIBS = $(mp01_node2_LDLIBS)
 
Index: testsuites/mptests/mp02/node1/Makefile.am
===================================================================
--- testsuites/mptests/mp02/node1/Makefile.am	(revision 2cd2ed3288e8ac35d69ec6f6140ad431b135109c)
+++ testsuites/mptests/mp02/node1/Makefile.am	(revision 48e02af9ca52c19fdc7300f8e3c6ad05a6952d94)
@@ -13,5 +13,5 @@
 AM_CPPFLAGS += -I$(top_srcdir)/../support/include
 
-LINK_OBJS = 
+LINK_OBJS = $(mp02_node1_OBJECTS)
 LINK_LIBS = $(mp02_node1_LDLIBS)
 
Index: testsuites/mptests/mp02/node2/Makefile.am
===================================================================
--- testsuites/mptests/mp02/node2/Makefile.am	(revision 2cd2ed3288e8ac35d69ec6f6140ad431b135109c)
+++ testsuites/mptests/mp02/node2/Makefile.am	(revision 48e02af9ca52c19fdc7300f8e3c6ad05a6952d94)
@@ -13,5 +13,5 @@
 AM_CPPFLAGS += -I$(top_srcdir)/../support/include
 
-LINK_OBJS = 
+LINK_OBJS = $(mp02_node2_OBJECTS)
 LINK_LIBS = $(mp02_node2_LDLIBS)
 
Index: testsuites/mptests/mp03/node1/Makefile.am
===================================================================
--- testsuites/mptests/mp03/node1/Makefile.am	(revision 2cd2ed3288e8ac35d69ec6f6140ad431b135109c)
+++ testsuites/mptests/mp03/node1/Makefile.am	(revision 48e02af9ca52c19fdc7300f8e3c6ad05a6952d94)
@@ -13,5 +13,5 @@
 AM_CPPFLAGS += -I$(top_srcdir)/../support/include
 
-LINK_OBJS = 
+LINK_OBJS = $(mp03_node1_OBJECTS)
 LINK_LIBS = $(mp03_node1_LDLIBS)
 
Index: testsuites/mptests/mp03/node2/Makefile.am
===================================================================
--- testsuites/mptests/mp03/node2/Makefile.am	(revision 2cd2ed3288e8ac35d69ec6f6140ad431b135109c)
+++ testsuites/mptests/mp03/node2/Makefile.am	(revision 48e02af9ca52c19fdc7300f8e3c6ad05a6952d94)
@@ -13,5 +13,5 @@
 AM_CPPFLAGS += -I$(top_srcdir)/../support/include
 
-LINK_OBJS = 
+LINK_OBJS = $(mp03_node2_OBJECTS)
 LINK_LIBS = $(mp03_node2_LDLIBS)
 
Index: testsuites/mptests/mp04/node1/Makefile.am
===================================================================
--- testsuites/mptests/mp04/node1/Makefile.am	(revision 2cd2ed3288e8ac35d69ec6f6140ad431b135109c)
+++ testsuites/mptests/mp04/node1/Makefile.am	(revision 48e02af9ca52c19fdc7300f8e3c6ad05a6952d94)
@@ -13,5 +13,5 @@
 AM_CPPFLAGS += -I$(top_srcdir)/../support/include
 
-LINK_OBJS = 
+LINK_OBJS = $(mp04_node1_OBJECTS)
 LINK_LIBS = $(mp04_node1_LDLIBS)
 
Index: testsuites/mptests/mp04/node2/Makefile.am
===================================================================
--- testsuites/mptests/mp04/node2/Makefile.am	(revision 2cd2ed3288e8ac35d69ec6f6140ad431b135109c)
+++ testsuites/mptests/mp04/node2/Makefile.am	(revision 48e02af9ca52c19fdc7300f8e3c6ad05a6952d94)
@@ -13,5 +13,5 @@
 AM_CPPFLAGS += -I$(top_srcdir)/../support/include
 
-LINK_OBJS = 
+LINK_OBJS = $(mp04_node2_OBJECTS)
 LINK_LIBS = $(mp04_node2_LDLIBS)
 
Index: testsuites/mptests/mp05/node1/Makefile.am
===================================================================
--- testsuites/mptests/mp05/node1/Makefile.am	(revision 2cd2ed3288e8ac35d69ec6f6140ad431b135109c)
+++ testsuites/mptests/mp05/node1/Makefile.am	(revision 48e02af9ca52c19fdc7300f8e3c6ad05a6952d94)
@@ -13,5 +13,5 @@
 AM_CPPFLAGS += -I$(top_srcdir)/../support/include
 
-LINK_OBJS = 
+LINK_OBJS = $(mp05_node1_OBJECTS)
 LINK_LIBS = $(mp05_node1_LDLIBS)
 
Index: testsuites/mptests/mp05/node2/Makefile.am
===================================================================
--- testsuites/mptests/mp05/node2/Makefile.am	(revision 2cd2ed3288e8ac35d69ec6f6140ad431b135109c)
+++ testsuites/mptests/mp05/node2/Makefile.am	(revision 48e02af9ca52c19fdc7300f8e3c6ad05a6952d94)
@@ -13,5 +13,5 @@
 AM_CPPFLAGS += -I$(top_srcdir)/../support/include
 
-LINK_OBJS = 
+LINK_OBJS = $(mp05_node2_OBJECTS)
 LINK_LIBS = $(mp05_node2_LDLIBS)
 
Index: testsuites/mptests/mp06/node1/Makefile.am
===================================================================
--- testsuites/mptests/mp06/node1/Makefile.am	(revision 2cd2ed3288e8ac35d69ec6f6140ad431b135109c)
+++ testsuites/mptests/mp06/node1/Makefile.am	(revision 48e02af9ca52c19fdc7300f8e3c6ad05a6952d94)
@@ -13,5 +13,5 @@
 AM_CPPFLAGS += -I$(top_srcdir)/../support/include
 
-LINK_OBJS = 
+LINK_OBJS = $(mp06_node1_OBJECTS)
 LINK_LIBS = $(mp06_node1_LDLIBS)
 
Index: testsuites/mptests/mp06/node2/Makefile.am
===================================================================
--- testsuites/mptests/mp06/node2/Makefile.am	(revision 2cd2ed3288e8ac35d69ec6f6140ad431b135109c)
+++ testsuites/mptests/mp06/node2/Makefile.am	(revision 48e02af9ca52c19fdc7300f8e3c6ad05a6952d94)
@@ -13,5 +13,5 @@
 AM_CPPFLAGS += -I$(top_srcdir)/../support/include
 
-LINK_OBJS = 
+LINK_OBJS = $(mp06_node2_OBJECTS)
 LINK_LIBS = $(mp06_node2_LDLIBS)
 
Index: testsuites/mptests/mp07/node1/Makefile.am
===================================================================
--- testsuites/mptests/mp07/node1/Makefile.am	(revision 2cd2ed3288e8ac35d69ec6f6140ad431b135109c)
+++ testsuites/mptests/mp07/node1/Makefile.am	(revision 48e02af9ca52c19fdc7300f8e3c6ad05a6952d94)
@@ -13,5 +13,5 @@
 AM_CPPFLAGS += -I$(top_srcdir)/../support/include
 
-LINK_OBJS = 
+LINK_OBJS = $(mp07_node1_OBJECTS)
 LINK_LIBS = $(mp07_node1_LDLIBS)
 
Index: testsuites/mptests/mp07/node2/Makefile.am
===================================================================
--- testsuites/mptests/mp07/node2/Makefile.am	(revision 2cd2ed3288e8ac35d69ec6f6140ad431b135109c)
+++ testsuites/mptests/mp07/node2/Makefile.am	(revision 48e02af9ca52c19fdc7300f8e3c6ad05a6952d94)
@@ -13,5 +13,5 @@
 AM_CPPFLAGS += -I$(top_srcdir)/../support/include
 
-LINK_OBJS = 
+LINK_OBJS = $(mp07_node2_OBJECTS)
 LINK_LIBS = $(mp07_node2_LDLIBS)
 
Index: testsuites/mptests/mp08/node1/Makefile.am
===================================================================
--- testsuites/mptests/mp08/node1/Makefile.am	(revision 2cd2ed3288e8ac35d69ec6f6140ad431b135109c)
+++ testsuites/mptests/mp08/node1/Makefile.am	(revision 48e02af9ca52c19fdc7300f8e3c6ad05a6952d94)
@@ -13,5 +13,5 @@
 AM_CPPFLAGS += -I$(top_srcdir)/../support/include
 
-LINK_OBJS = 
+LINK_OBJS = $(mp08_node1_OBJECTS)
 LINK_LIBS = $(mp08_node1_LDLIBS)
 
Index: testsuites/mptests/mp08/node2/Makefile.am
===================================================================
--- testsuites/mptests/mp08/node2/Makefile.am	(revision 2cd2ed3288e8ac35d69ec6f6140ad431b135109c)
+++ testsuites/mptests/mp08/node2/Makefile.am	(revision 48e02af9ca52c19fdc7300f8e3c6ad05a6952d94)
@@ -13,5 +13,5 @@
 AM_CPPFLAGS += -I$(top_srcdir)/../support/include
 
-LINK_OBJS = 
+LINK_OBJS = $(mp08_node2_OBJECTS)
 LINK_LIBS = $(mp08_node2_LDLIBS)
 
Index: testsuites/mptests/mp09/node1/Makefile.am
===================================================================
--- testsuites/mptests/mp09/node1/Makefile.am	(revision 2cd2ed3288e8ac35d69ec6f6140ad431b135109c)
+++ testsuites/mptests/mp09/node1/Makefile.am	(revision 48e02af9ca52c19fdc7300f8e3c6ad05a6952d94)
@@ -13,5 +13,5 @@
 AM_CPPFLAGS += -I$(top_srcdir)/../support/include
 
-LINK_OBJS = 
+LINK_OBJS = $(mp09_node1_OBJECTS)
 LINK_LIBS = $(mp09_node1_LDLIBS)
 
Index: testsuites/mptests/mp09/node2/Makefile.am
===================================================================
--- testsuites/mptests/mp09/node2/Makefile.am	(revision 2cd2ed3288e8ac35d69ec6f6140ad431b135109c)
+++ testsuites/mptests/mp09/node2/Makefile.am	(revision 48e02af9ca52c19fdc7300f8e3c6ad05a6952d94)
@@ -13,5 +13,5 @@
 AM_CPPFLAGS += -I$(top_srcdir)/../support/include
 
-LINK_OBJS = 
+LINK_OBJS = $(mp09_node2_OBJECTS)
 LINK_LIBS = $(mp09_node2_LDLIBS)
 
Index: testsuites/mptests/mp10/node1/Makefile.am
===================================================================
--- testsuites/mptests/mp10/node1/Makefile.am	(revision 2cd2ed3288e8ac35d69ec6f6140ad431b135109c)
+++ testsuites/mptests/mp10/node1/Makefile.am	(revision 48e02af9ca52c19fdc7300f8e3c6ad05a6952d94)
@@ -13,5 +13,5 @@
 AM_CPPFLAGS += -I$(top_srcdir)/../support/include
 
-LINK_OBJS = 
+LINK_OBJS = $(mp10_node1_OBJECTS)
 LINK_LIBS = $(mp10_node1_LDLIBS)
 
Index: testsuites/mptests/mp10/node2/Makefile.am
===================================================================
--- testsuites/mptests/mp10/node2/Makefile.am	(revision 2cd2ed3288e8ac35d69ec6f6140ad431b135109c)
+++ testsuites/mptests/mp10/node2/Makefile.am	(revision 48e02af9ca52c19fdc7300f8e3c6ad05a6952d94)
@@ -13,5 +13,5 @@
 AM_CPPFLAGS += -I$(top_srcdir)/../support/include
 
-LINK_OBJS = 
+LINK_OBJS = $(mp10_node2_OBJECTS)
 LINK_LIBS = $(mp10_node2_LDLIBS)
 
Index: testsuites/mptests/mp11/node1/Makefile.am
===================================================================
--- testsuites/mptests/mp11/node1/Makefile.am	(revision 2cd2ed3288e8ac35d69ec6f6140ad431b135109c)
+++ testsuites/mptests/mp11/node1/Makefile.am	(revision 48e02af9ca52c19fdc7300f8e3c6ad05a6952d94)
@@ -13,5 +13,5 @@
 AM_CPPFLAGS += -I$(top_srcdir)/../support/include
 
-LINK_OBJS = 
+LINK_OBJS = $(mp11_node1_OBJECTS)
 LINK_LIBS = $(mp11_node1_LDLIBS)
 
Index: testsuites/mptests/mp11/node2/Makefile.am
===================================================================
--- testsuites/mptests/mp11/node2/Makefile.am	(revision 2cd2ed3288e8ac35d69ec6f6140ad431b135109c)
+++ testsuites/mptests/mp11/node2/Makefile.am	(revision 48e02af9ca52c19fdc7300f8e3c6ad05a6952d94)
@@ -13,5 +13,5 @@
 AM_CPPFLAGS += -I$(top_srcdir)/../support/include
 
-LINK_OBJS = 
+LINK_OBJS = $(mp11_node2_OBJECTS)
 LINK_LIBS = $(mp11_node2_LDLIBS)
 
Index: testsuites/mptests/mp12/node1/Makefile.am
===================================================================
--- testsuites/mptests/mp12/node1/Makefile.am	(revision 2cd2ed3288e8ac35d69ec6f6140ad431b135109c)
+++ testsuites/mptests/mp12/node1/Makefile.am	(revision 48e02af9ca52c19fdc7300f8e3c6ad05a6952d94)
@@ -13,5 +13,5 @@
 AM_CPPFLAGS += -I$(top_srcdir)/../support/include
 
-LINK_OBJS = 
+LINK_OBJS = $(mp12_node1_OBJECTS)
 LINK_LIBS = $(mp12_node1_LDLIBS)
 
Index: testsuites/mptests/mp12/node2/Makefile.am
===================================================================
--- testsuites/mptests/mp12/node2/Makefile.am	(revision 2cd2ed3288e8ac35d69ec6f6140ad431b135109c)
+++ testsuites/mptests/mp12/node2/Makefile.am	(revision 48e02af9ca52c19fdc7300f8e3c6ad05a6952d94)
@@ -13,5 +13,5 @@
 AM_CPPFLAGS += -I$(top_srcdir)/../support/include
 
-LINK_OBJS = 
+LINK_OBJS = $(mp12_node2_OBJECTS)
 LINK_LIBS = $(mp12_node2_LDLIBS)
 
Index: testsuites/mptests/mp13/node1/Makefile.am
===================================================================
--- testsuites/mptests/mp13/node1/Makefile.am	(revision 2cd2ed3288e8ac35d69ec6f6140ad431b135109c)
+++ testsuites/mptests/mp13/node1/Makefile.am	(revision 48e02af9ca52c19fdc7300f8e3c6ad05a6952d94)
@@ -13,5 +13,5 @@
 AM_CPPFLAGS += -I$(top_srcdir)/../support/include
 
-LINK_OBJS = 
+LINK_OBJS = $(mp13_node1_OBJECTS)
 LINK_LIBS = $(mp13_node1_LDLIBS)
 
Index: testsuites/mptests/mp13/node2/Makefile.am
===================================================================
--- testsuites/mptests/mp13/node2/Makefile.am	(revision 2cd2ed3288e8ac35d69ec6f6140ad431b135109c)
+++ testsuites/mptests/mp13/node2/Makefile.am	(revision 48e02af9ca52c19fdc7300f8e3c6ad05a6952d94)
@@ -13,5 +13,5 @@
 AM_CPPFLAGS += -I$(top_srcdir)/../support/include
 
-LINK_OBJS = 
+LINK_OBJS = $(mp13_node2_OBJECTS)
 LINK_LIBS = $(mp13_node2_LDLIBS)
 
Index: testsuites/mptests/mp14/node1/Makefile.am
===================================================================
--- testsuites/mptests/mp14/node1/Makefile.am	(revision 2cd2ed3288e8ac35d69ec6f6140ad431b135109c)
+++ testsuites/mptests/mp14/node1/Makefile.am	(revision 48e02af9ca52c19fdc7300f8e3c6ad05a6952d94)
@@ -15,5 +15,5 @@
 AM_CPPFLAGS += -I$(top_srcdir)/../support/include
 
-LINK_OBJS = 
+LINK_OBJS = $(mp14_node1_OBJECTS)
 LINK_LIBS = $(mp14_node1_LDLIBS)
 
Index: testsuites/mptests/mp14/node2/Makefile.am
===================================================================
--- testsuites/mptests/mp14/node2/Makefile.am	(revision 2cd2ed3288e8ac35d69ec6f6140ad431b135109c)
+++ testsuites/mptests/mp14/node2/Makefile.am	(revision 48e02af9ca52c19fdc7300f8e3c6ad05a6952d94)
@@ -15,5 +15,5 @@
 AM_CPPFLAGS += -I$(top_srcdir)/../support/include
 
-LINK_OBJS = 
+LINK_OBJS = $(mp14_node2_OBJECTS)
 LINK_LIBS = $(mp14_node2_LDLIBS)
 