Index: contrib/crossrpms/rtems4.11/arm-eabi/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.11/arm-eabi/Makefile.am	(revision ed3821c3920da6c65eb676cb436eed36f63ae6be)
+++ contrib/crossrpms/rtems4.11/arm-eabi/Makefile.am	(revision 49df63a203983407f77fd08e6316365eb7db8463)
@@ -14,5 +14,5 @@
 GCC_VERS = 4.6.2
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 2
+GCC_RPMREL = 3
 NEWLIB_VERS = 1.19.0
 NEWLIB_PKGVERS = $(NEWLIB_VERS)
Index: contrib/crossrpms/rtems4.11/arm/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.11/arm/Makefile.am	(revision ed3821c3920da6c65eb676cb436eed36f63ae6be)
+++ contrib/crossrpms/rtems4.11/arm/Makefile.am	(revision 49df63a203983407f77fd08e6316365eb7db8463)
@@ -14,5 +14,5 @@
 GCC_VERS = 4.6.2
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 2
+GCC_RPMREL = 3
 
 NEWLIB_VERS = 1.19.0
Index: contrib/crossrpms/rtems4.11/avr/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.11/avr/Makefile.am	(revision ed3821c3920da6c65eb676cb436eed36f63ae6be)
+++ contrib/crossrpms/rtems4.11/avr/Makefile.am	(revision 49df63a203983407f77fd08e6316365eb7db8463)
@@ -14,5 +14,5 @@
 GCC_VERS = 4.6.2
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 2
+GCC_RPMREL = 3
 NEWLIB_VERS = 1.19.0
 NEWLIB_PKGVERS = $(NEWLIB_VERS)
Index: contrib/crossrpms/rtems4.11/bfin/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.11/bfin/Makefile.am	(revision ed3821c3920da6c65eb676cb436eed36f63ae6be)
+++ contrib/crossrpms/rtems4.11/bfin/Makefile.am	(revision 49df63a203983407f77fd08e6316365eb7db8463)
@@ -14,5 +14,5 @@
 GCC_VERS = 4.6.2
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 2
+GCC_RPMREL = 3
 NEWLIB_VERS = 1.19.0
 NEWLIB_PKGVERS = $(NEWLIB_VERS)
Index: contrib/crossrpms/rtems4.11/h8300/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.11/h8300/Makefile.am	(revision ed3821c3920da6c65eb676cb436eed36f63ae6be)
+++ contrib/crossrpms/rtems4.11/h8300/Makefile.am	(revision 49df63a203983407f77fd08e6316365eb7db8463)
@@ -14,5 +14,5 @@
 GCC_VERS = 4.5.3
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 20
+GCC_RPMREL = 21
 NEWLIB_VERS = 1.19.0
 NEWLIB_PKGVERS = $(NEWLIB_VERS)
Index: contrib/crossrpms/rtems4.11/i386/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.11/i386/Makefile.am	(revision ed3821c3920da6c65eb676cb436eed36f63ae6be)
+++ contrib/crossrpms/rtems4.11/i386/Makefile.am	(revision 49df63a203983407f77fd08e6316365eb7db8463)
@@ -14,5 +14,5 @@
 GCC_VERS = 4.6.2
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 2
+GCC_RPMREL = 3
 NEWLIB_VERS = 1.19.0
 NEWLIB_PKGVERS = $(NEWLIB_VERS)
Index: contrib/crossrpms/rtems4.11/lm32/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.11/lm32/Makefile.am	(revision ed3821c3920da6c65eb676cb436eed36f63ae6be)
+++ contrib/crossrpms/rtems4.11/lm32/Makefile.am	(revision 49df63a203983407f77fd08e6316365eb7db8463)
@@ -14,5 +14,5 @@
 GCC_VERS = 4.5.3
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 20
+GCC_RPMREL = 21
 NEWLIB_VERS = 1.19.0
 NEWLIB_PKGVERS = $(NEWLIB_VERS)
Index: contrib/crossrpms/rtems4.11/m32c/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.11/m32c/Makefile.am	(revision ed3821c3920da6c65eb676cb436eed36f63ae6be)
+++ contrib/crossrpms/rtems4.11/m32c/Makefile.am	(revision 49df63a203983407f77fd08e6316365eb7db8463)
@@ -14,5 +14,5 @@
 GCC_VERS = 4.6.2
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 2
+GCC_RPMREL = 3
 NEWLIB_VERS = 1.19.0
 NEWLIB_PKGVERS = $(NEWLIB_VERS)
Index: contrib/crossrpms/rtems4.11/m32r/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.11/m32r/Makefile.am	(revision ed3821c3920da6c65eb676cb436eed36f63ae6be)
+++ contrib/crossrpms/rtems4.11/m32r/Makefile.am	(revision 49df63a203983407f77fd08e6316365eb7db8463)
@@ -14,5 +14,5 @@
 GCC_VERS = 4.6.2
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 2
+GCC_RPMREL = 3
 NEWLIB_VERS = 1.19.0
 NEWLIB_PKGVERS = $(NEWLIB_VERS)
Index: contrib/crossrpms/rtems4.11/m68k/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.11/m68k/Makefile.am	(revision ed3821c3920da6c65eb676cb436eed36f63ae6be)
+++ contrib/crossrpms/rtems4.11/m68k/Makefile.am	(revision 49df63a203983407f77fd08e6316365eb7db8463)
@@ -14,5 +14,5 @@
 GCC_VERS = 4.6.2
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 2
+GCC_RPMREL = 3
 NEWLIB_VERS = 1.19.0
 NEWLIB_PKGVERS = $(NEWLIB_VERS)
Index: contrib/crossrpms/rtems4.11/mips/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.11/mips/Makefile.am	(revision ed3821c3920da6c65eb676cb436eed36f63ae6be)
+++ contrib/crossrpms/rtems4.11/mips/Makefile.am	(revision 49df63a203983407f77fd08e6316365eb7db8463)
@@ -14,5 +14,5 @@
 GCC_VERS = 4.6.2
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 2
+GCC_RPMREL = 3
 NEWLIB_VERS = 1.19.0
 NEWLIB_PKGVERS = $(NEWLIB_VERS)
Index: contrib/crossrpms/rtems4.11/powerpc/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.11/powerpc/Makefile.am	(revision ed3821c3920da6c65eb676cb436eed36f63ae6be)
+++ contrib/crossrpms/rtems4.11/powerpc/Makefile.am	(revision 49df63a203983407f77fd08e6316365eb7db8463)
@@ -14,5 +14,5 @@
 GCC_VERS = 4.6.2
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 2
+GCC_RPMREL = 3
 NEWLIB_VERS = 1.19.0
 NEWLIB_PKGVERS = $(NEWLIB_VERS)
Index: contrib/crossrpms/rtems4.11/sh/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.11/sh/Makefile.am	(revision ed3821c3920da6c65eb676cb436eed36f63ae6be)
+++ contrib/crossrpms/rtems4.11/sh/Makefile.am	(revision 49df63a203983407f77fd08e6316365eb7db8463)
@@ -14,5 +14,5 @@
 GCC_VERS = 4.6.2
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 2
+GCC_RPMREL = 3
 NEWLIB_VERS = 1.19.0
 NEWLIB_PKGVERS = $(NEWLIB_VERS)
Index: contrib/crossrpms/rtems4.11/sparc/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.11/sparc/Makefile.am	(revision ed3821c3920da6c65eb676cb436eed36f63ae6be)
+++ contrib/crossrpms/rtems4.11/sparc/Makefile.am	(revision 49df63a203983407f77fd08e6316365eb7db8463)
@@ -14,5 +14,5 @@
 GCC_VERS = 4.6.2
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 2
+GCC_RPMREL = 3
 NEWLIB_VERS = 1.19.0
 NEWLIB_PKGVERS = $(NEWLIB_VERS)
Index: contrib/crossrpms/rtems4.11/sparc64/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.11/sparc64/Makefile.am	(revision ed3821c3920da6c65eb676cb436eed36f63ae6be)
+++ contrib/crossrpms/rtems4.11/sparc64/Makefile.am	(revision 49df63a203983407f77fd08e6316365eb7db8463)
@@ -14,5 +14,5 @@
 GCC_VERS = 4.6.2
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 2
+GCC_RPMREL = 3
 NEWLIB_VERS = 1.19.0
 NEWLIB_PKGVERS = $(NEWLIB_VERS)