Index: c/src/lib/libbsp/sh/gensh1/ChangeLog
===================================================================
--- c/src/lib/libbsp/sh/gensh1/ChangeLog	(revision 5e3745fb40ff93429385ffbafeabcaaa0e323354)
+++ c/src/lib/libbsp/sh/gensh1/ChangeLog	(revision 52cfc7de8720e1f0fdbff21a2092ce65abd9a3b9)
@@ -1,2 +1,7 @@
+2004-04-22	Ralf Corsepius <ralf_corsepius@rtems.org>
+
+	* include/bsp.h: Split out tmtest27 support.
+	* include/tm27.h: New.
+
 2004-04-21	Ralf Corsepius <ralf_corsepius@rtems.org>
 
Index: c/src/lib/libbsp/sh/gensh1/include/bsp.h
===================================================================
--- c/src/lib/libbsp/sh/gensh1/include/bsp.h	(revision 5e3745fb40ff93429385ffbafeabcaaa0e323354)
+++ c/src/lib/libbsp/sh/gensh1/include/bsp.h	(revision 52cfc7de8720e1f0fdbff21a2092ce65abd9a3b9)
@@ -56,22 +56,4 @@
 #endif
 
-/*
- *  Stuff for Time Test 27
- */
-
-#define MUST_WAIT_FOR_INTERRUPT 0
-
-#define Install_tm27_vector( handler ) \
-{ \
-  rtems_isr_entry ignored ; \
-  rtems_interrupt_catch( (handler), 0, &ignored ) ; \
-}
-
-#define Cause_tm27_intr()
-
-#define Clear_tm27_intr()
-
-#define Lower_tm27_intr()
-
 /* Constants */
 
Index: c/src/lib/libbsp/sh/gensh1/include/tm27.h
===================================================================
--- c/src/lib/libbsp/sh/gensh1/include/tm27.h	(revision 52cfc7de8720e1f0fdbff21a2092ce65abd9a3b9)
+++ c/src/lib/libbsp/sh/gensh1/include/tm27.h	(revision 52cfc7de8720e1f0fdbff21a2092ce65abd9a3b9)
@@ -0,0 +1,38 @@
+/*
+ *  tm27.h
+ *
+ *  The license and distribution terms for this file may be
+ *  found in the file LICENSE in this distribution or at
+ *  http://www.rtems.com/license/LICENSE.
+ *
+ *  $Id$
+ */
+
+#ifndef _TMTEST27
+#error "This is an RTEMS internal file you must not include directly."
+#endif
+
+#ifndef __tm27_h
+#define __tm27_h
+
+/*
+ *  Stuff for Time Test 27
+ */
+
+#define MUST_WAIT_FOR_INTERRUPT 0
+
+#define Install_tm27_vector( handler ) \
+{ \
+  rtems_isr_entry ignored ; \
+  rtems_interrupt_catch( (handler), 0, &ignored ) ; \
+}
+
+#define Cause_tm27_intr()
+
+#define Clear_tm27_intr()
+
+#define Lower_tm27_intr()
+
+
+
+#endif
Index: c/src/lib/libbsp/sh/gensh2/ChangeLog
===================================================================
--- c/src/lib/libbsp/sh/gensh2/ChangeLog	(revision 5e3745fb40ff93429385ffbafeabcaaa0e323354)
+++ c/src/lib/libbsp/sh/gensh2/ChangeLog	(revision 52cfc7de8720e1f0fdbff21a2092ce65abd9a3b9)
@@ -1,2 +1,7 @@
+2004-04-22	Ralf Corsepius <ralf_corsepius@rtems.org>
+
+	* include/bsp.h: Split out tmtest27 support.
+	* include/tm27.h: New.
+
 2004-04-21	Ralf Corsepius <ralf_corsepius@rtems.org>
 
Index: c/src/lib/libbsp/sh/gensh2/include/bsp.h
===================================================================
--- c/src/lib/libbsp/sh/gensh2/include/bsp.h	(revision 5e3745fb40ff93429385ffbafeabcaaa0e323354)
+++ c/src/lib/libbsp/sh/gensh2/include/bsp.h	(revision 52cfc7de8720e1f0fdbff21a2092ce65abd9a3b9)
@@ -72,22 +72,4 @@
 #endif
 
-/*
- *  Stuff for Time Test 27
- */
-
-#define MUST_WAIT_FOR_INTERRUPT 0
-
-#define Install_tm27_vector( handler ) \
-{ \
-  rtems_isr_entry ignored ; \
-  rtems_interrupt_catch( (handler), 0, &ignored ) ; \
-}
-
-#define Cause_tm27_intr()
-
-#define Clear_tm27_intr()
-
-#define Lower_tm27_intr()
-
 /* Constants */
 
Index: c/src/lib/libbsp/sh/gensh2/include/tm27.h
===================================================================
--- c/src/lib/libbsp/sh/gensh2/include/tm27.h	(revision 52cfc7de8720e1f0fdbff21a2092ce65abd9a3b9)
+++ c/src/lib/libbsp/sh/gensh2/include/tm27.h	(revision 52cfc7de8720e1f0fdbff21a2092ce65abd9a3b9)
@@ -0,0 +1,38 @@
+/*
+ *  tm27.h
+ *
+ *  The license and distribution terms for this file may be
+ *  found in the file LICENSE in this distribution or at
+ *  http://www.rtems.com/license/LICENSE.
+ *
+ *  $Id$
+ */
+
+#ifndef _TMTEST27
+#error "This is an RTEMS internal file you must not include directly."
+#endif
+
+#ifndef __tm27_h
+#define __tm27_h
+
+/*
+ *  Stuff for Time Test 27
+ */
+
+#define MUST_WAIT_FOR_INTERRUPT 0
+
+#define Install_tm27_vector( handler ) \
+{ \
+  rtems_isr_entry ignored ; \
+  rtems_interrupt_catch( (handler), 0, &ignored ) ; \
+}
+
+#define Cause_tm27_intr()
+
+#define Clear_tm27_intr()
+
+#define Lower_tm27_intr()
+
+
+
+#endif
Index: c/src/lib/libbsp/sh/gensh4/ChangeLog
===================================================================
--- c/src/lib/libbsp/sh/gensh4/ChangeLog	(revision 5e3745fb40ff93429385ffbafeabcaaa0e323354)
+++ c/src/lib/libbsp/sh/gensh4/ChangeLog	(revision 52cfc7de8720e1f0fdbff21a2092ce65abd9a3b9)
@@ -1,2 +1,7 @@
+2004-04-22	Ralf Corsepius <ralf_corsepius@rtems.org>
+
+	* include/bsp.h: Split out tmtest27 support.
+	* include/tm27.h: New.
+
 2004-04-21	Ralf Corsepius <ralf_corsepius@rtems.org>
 
Index: c/src/lib/libbsp/sh/gensh4/include/bsp.h
===================================================================
--- c/src/lib/libbsp/sh/gensh4/include/bsp.h	(revision 5e3745fb40ff93429385ffbafeabcaaa0e323354)
+++ c/src/lib/libbsp/sh/gensh4/include/bsp.h	(revision 52cfc7de8720e1f0fdbff21a2092ce65abd9a3b9)
@@ -61,43 +61,4 @@
 #define CONFIGURE_INTERRUPT_STACK_MEMORY  (4 * 1024)
 
-/*
- *  Stuff for Time Test 27
- */
-
-#define MUST_WAIT_FOR_INTERRUPT 1
-
-#ifndef SH7750_EVT_WDT_ITI
-#   error "..."
-#endif
-
-#define Install_tm27_vector( handler ) \
-{ \
-    rtems_isr_entry old_handler; \
-    rtems_status_code status; \
-    status = rtems_interrupt_catch( (handler), \
-            SH7750_EVT_TO_NUM(SH7750_EVT_WDT_ITI), &old_handler); \
-    if (status != RTEMS_SUCCESSFUL) \
-        printf("Status of rtems_interrupt_catch = %d", status); \
-}
-
-#define Cause_tm27_intr() \
-{ \
-    *(volatile uint16_t*)SH7750_IPRB |= 0xf000; \
-    *(volatile uint16_t*)SH7750_WTCSR = SH7750_WTCSR_KEY; \
-    *(volatile uint16_t*)SH7750_WTCNT = SH7750_WTCNT_KEY | 0xfe; \
-    *(volatile uint16_t*)SH7750_WTCSR = \
-                            SH7750_WTCSR_KEY | SH7750_WTCSR_TME; \
-}
-
-#define Clear_tm27_intr() \
-{ \
-    *(volatile uint16_t*)SH7750_WTCSR = SH7750_WTCSR_KEY; \
-}
-
-#define Lower_tm27_intr() \
-{ \
-    sh_set_interrupt_level((SH7750_IPRB & 0xf000) << SH4_SR_IMASK_S); \
-}
-
 /* Constants */
 
Index: c/src/lib/libbsp/sh/gensh4/include/tm27.h
===================================================================
--- c/src/lib/libbsp/sh/gensh4/include/tm27.h	(revision 52cfc7de8720e1f0fdbff21a2092ce65abd9a3b9)
+++ c/src/lib/libbsp/sh/gensh4/include/tm27.h	(revision 52cfc7de8720e1f0fdbff21a2092ce65abd9a3b9)
@@ -0,0 +1,59 @@
+/*
+ *  tm27.h
+ *
+ *  The license and distribution terms for this file may be
+ *  found in the file LICENSE in this distribution or at
+ *  http://www.rtems.com/license/LICENSE.
+ *
+ *  $Id$
+ */
+
+#ifndef _TMTEST27
+#error "This is an RTEMS internal file you must not include directly."
+#endif
+
+#ifndef __tm27_h
+#define __tm27_h
+
+/*
+ *  Stuff for Time Test 27
+ */
+
+#define MUST_WAIT_FOR_INTERRUPT 1
+
+#ifndef SH7750_EVT_WDT_ITI
+#   error "..."
+#endif
+
+#define Install_tm27_vector( handler ) \
+{ \
+    rtems_isr_entry old_handler; \
+    rtems_status_code status; \
+    status = rtems_interrupt_catch( (handler), \
+            SH7750_EVT_TO_NUM(SH7750_EVT_WDT_ITI), &old_handler); \
+    if (status != RTEMS_SUCCESSFUL) \
+        printf("Status of rtems_interrupt_catch = %d", status); \
+}
+
+#define Cause_tm27_intr() \
+{ \
+    *(volatile uint16_t*)SH7750_IPRB |= 0xf000; \
+    *(volatile uint16_t*)SH7750_WTCSR = SH7750_WTCSR_KEY; \
+    *(volatile uint16_t*)SH7750_WTCNT = SH7750_WTCNT_KEY | 0xfe; \
+    *(volatile uint16_t*)SH7750_WTCSR = \
+                            SH7750_WTCSR_KEY | SH7750_WTCSR_TME; \
+}
+
+#define Clear_tm27_intr() \
+{ \
+    *(volatile uint16_t*)SH7750_WTCSR = SH7750_WTCSR_KEY; \
+}
+
+#define Lower_tm27_intr() \
+{ \
+    sh_set_interrupt_level((SH7750_IPRB & 0xf000) << SH4_SR_IMASK_S); \
+}
+
+
+
+#endif
Index: c/src/lib/libbsp/sh/shsim/ChangeLog
===================================================================
--- c/src/lib/libbsp/sh/shsim/ChangeLog	(revision 5e3745fb40ff93429385ffbafeabcaaa0e323354)
+++ c/src/lib/libbsp/sh/shsim/ChangeLog	(revision 52cfc7de8720e1f0fdbff21a2092ce65abd9a3b9)
@@ -1,2 +1,7 @@
+2004-04-22	Ralf Corsepius <ralf_corsepius@rtems.org>
+
+	* include/bsp.h: Split out tmtest27 support.
+	* include/tm27.h: New.
+
 2004-04-21	Ralf Corsepius <ralf_corsepius@rtems.org>
 
Index: c/src/lib/libbsp/sh/shsim/include/bsp.h
===================================================================
--- c/src/lib/libbsp/sh/shsim/include/bsp.h	(revision 5e3745fb40ff93429385ffbafeabcaaa0e323354)
+++ c/src/lib/libbsp/sh/shsim/include/bsp.h	(revision 52cfc7de8720e1f0fdbff21a2092ce65abd9a3b9)
@@ -49,16 +49,4 @@
 #include <gdbsci.h>
 #include <rtems/devnull.h>
-
-/*
- *  Stuff for Time Test 27
- *
- * FIXME: This should not be here.
- */
-
-#define MUST_WAIT_FOR_INTERRUPT 0
-
-#define Install_tm27_vector( handler )
-#define Cause_tm27_intr()
-#define Clear_tm27_intr()
 
 /* Constants */
Index: c/src/lib/libbsp/sh/shsim/include/tm27.h
===================================================================
--- c/src/lib/libbsp/sh/shsim/include/tm27.h	(revision 52cfc7de8720e1f0fdbff21a2092ce65abd9a3b9)
+++ c/src/lib/libbsp/sh/shsim/include/tm27.h	(revision 52cfc7de8720e1f0fdbff21a2092ce65abd9a3b9)
@@ -0,0 +1,32 @@
+/*
+ *  tm27.h
+ *
+ *  The license and distribution terms for this file may be
+ *  found in the file LICENSE in this distribution or at
+ *  http://www.rtems.com/license/LICENSE.
+ *
+ *  $Id$
+ */
+
+#ifndef _TMTEST27
+#error "This is an RTEMS internal file you must not include directly."
+#endif
+
+#ifndef __tm27_h
+#define __tm27_h
+
+/*
+ *  Stuff for Time Test 27
+ *
+ * FIXME: This should not be here.
+ */
+
+#define MUST_WAIT_FOR_INTERRUPT 0
+
+#define Install_tm27_vector( handler )
+#define Cause_tm27_intr()
+#define Clear_tm27_intr()
+
+
+
+#endif
Index: c/src/lib/libbsp/sh/simsh4/ChangeLog
===================================================================
--- c/src/lib/libbsp/sh/simsh4/ChangeLog	(revision 5e3745fb40ff93429385ffbafeabcaaa0e323354)
+++ c/src/lib/libbsp/sh/simsh4/ChangeLog	(revision 52cfc7de8720e1f0fdbff21a2092ce65abd9a3b9)
@@ -1,2 +1,7 @@
+2004-04-22	Ralf Corsepius <ralf_corsepius@rtems.org>
+
+	* include/bsp.h: Split out tmtest27 support.
+	* include/tm27.h: New.
+
 2004-04-21	Ralf Corsepius <ralf_corsepius@rtems.org>
 
Index: c/src/lib/libbsp/sh/simsh4/include/bsp.h
===================================================================
--- c/src/lib/libbsp/sh/simsh4/include/bsp.h	(revision 5e3745fb40ff93429385ffbafeabcaaa0e323354)
+++ c/src/lib/libbsp/sh/simsh4/include/bsp.h	(revision 52cfc7de8720e1f0fdbff21a2092ce65abd9a3b9)
@@ -65,22 +65,4 @@
 #define CLOCK_VECTOR 32
 
-/*
- *  Stuff for Time Test 27
- */
-
-#define MUST_WAIT_FOR_INTERRUPT 0
-
-#define Install_tm27_vector( handler ) \
-{ \
-  rtems_isr_entry ignored ; \
-  rtems_interrupt_catch( (handler), 0, &ignored ) ; \
-}
-
-#define Cause_tm27_intr()
-
-#define Clear_tm27_intr()
-
-#define Lower_tm27_intr()
-
 /* Constants */
 
Index: c/src/lib/libbsp/sh/simsh4/include/tm27.h
===================================================================
--- c/src/lib/libbsp/sh/simsh4/include/tm27.h	(revision 52cfc7de8720e1f0fdbff21a2092ce65abd9a3b9)
+++ c/src/lib/libbsp/sh/simsh4/include/tm27.h	(revision 52cfc7de8720e1f0fdbff21a2092ce65abd9a3b9)
@@ -0,0 +1,38 @@
+/*
+ *  tm27.h
+ *
+ *  The license and distribution terms for this file may be
+ *  found in the file LICENSE in this distribution or at
+ *  http://www.rtems.com/license/LICENSE.
+ *
+ *  $Id$
+ */
+
+#ifndef _TMTEST27
+#error "This is an RTEMS internal file you must not include directly."
+#endif
+
+#ifndef __tm27_h
+#define __tm27_h
+
+/*
+ *  Stuff for Time Test 27
+ */
+
+#define MUST_WAIT_FOR_INTERRUPT 0
+
+#define Install_tm27_vector( handler ) \
+{ \
+  rtems_isr_entry ignored ; \
+  rtems_interrupt_catch( (handler), 0, &ignored ) ; \
+}
+
+#define Cause_tm27_intr()
+
+#define Clear_tm27_intr()
+
+#define Lower_tm27_intr()
+
+
+
+#endif