Index: cpukit/score/cpu/a29k/ChangeLog
===================================================================
--- cpukit/score/cpu/a29k/ChangeLog	(revision 4f0b287a4aa0d948d61f5c2ef1915c4db24f30e9)
+++ cpukit/score/cpu/a29k/ChangeLog	(revision 53f67279d744af9c810b5d4ba36575b09feb5e7f)
@@ -1,2 +1,10 @@
+2002-07-22	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: Use .$(OBJEXT) instead of .o.
+
+2002-07-22	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: Use . instead of .o.
+
 2002-07-05	Joel Sherrill <joel@OARcorp.com>
 
Index: cpukit/score/cpu/a29k/Makefile.am
===================================================================
--- cpukit/score/cpu/a29k/Makefile.am	(revision 4f0b287a4aa0d948d61f5c2ef1915c4db24f30e9)
+++ cpukit/score/cpu/a29k/Makefile.am	(revision 53f67279d744af9c810b5d4ba36575b09feb5e7f)
@@ -34,8 +34,8 @@
 
 C_FILES = cpu.c
-C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.o)
+C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.$(OBJEXT))
 
 S_FILES = cpu_asm.S sig.S
-S_O_FILES = $(S_FILES:%.S=$(ARCH)/%.o)
+S_O_FILES = $(S_FILES:%.S=$(ARCH)/%.$(OBJEXT))
 
 REL = $(ARCH)/rtems-cpu.rel
Index: cpukit/score/cpu/arm/ChangeLog
===================================================================
--- cpukit/score/cpu/arm/ChangeLog	(revision 4f0b287a4aa0d948d61f5c2ef1915c4db24f30e9)
+++ cpukit/score/cpu/arm/ChangeLog	(revision 53f67279d744af9c810b5d4ba36575b09feb5e7f)
@@ -1,2 +1,10 @@
+2002-07-22	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: Use .$(OBJEXT) instead of .o.
+
+2002-07-22	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: Use . instead of .o.
+
 2002-07-17	Jay Monkman <jtm@smoothsmoothie.com>
 
Index: cpukit/score/cpu/arm/Makefile.am
===================================================================
--- cpukit/score/cpu/arm/Makefile.am	(revision 4f0b287a4aa0d948d61f5c2ef1915c4db24f30e9)
+++ cpukit/score/cpu/arm/Makefile.am	(revision 53f67279d744af9c810b5d4ba36575b09feb5e7f)
@@ -34,8 +34,8 @@
 
 C_FILES = cpu.c
-C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.o)
+C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.$(OBJEXT))
 
 S_FILES = cpu_asm.S
-S_O_FILES = $(S_FILES:%.S=$(ARCH)/%.o)
+S_O_FILES = $(S_FILES:%.S=$(ARCH)/%.$(OBJEXT))
 
 REL = $(ARCH)/rtems-cpu.rel
Index: cpukit/score/cpu/c4x/ChangeLog
===================================================================
--- cpukit/score/cpu/c4x/ChangeLog	(revision 4f0b287a4aa0d948d61f5c2ef1915c4db24f30e9)
+++ cpukit/score/cpu/c4x/ChangeLog	(revision 53f67279d744af9c810b5d4ba36575b09feb5e7f)
@@ -1,2 +1,10 @@
+2002-07-22	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: Use .$(OBJEXT) instead of .o.
+
+2002-07-22	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: Use . instead of .o.
+
 2002-07-05	Joel Sherrill <joel@OARcorp.com>
 
Index: cpukit/score/cpu/c4x/Makefile.am
===================================================================
--- cpukit/score/cpu/c4x/Makefile.am	(revision 4f0b287a4aa0d948d61f5c2ef1915c4db24f30e9)
+++ cpukit/score/cpu/c4x/Makefile.am	(revision 53f67279d744af9c810b5d4ba36575b09feb5e7f)
@@ -34,8 +34,8 @@
 
 C_FILES = cpu.c irq.c
-C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.o)
+C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.$(OBJEXT))
 
 S_FILES = cpu_asm.S
-S_O_FILES = $(S_FILES:%.S=$(ARCH)/%.o)
+S_O_FILES = $(S_FILES:%.S=$(ARCH)/%.$(OBJEXT))
 
 REL = $(ARCH)/rtems-cpu.rel
Index: cpukit/score/cpu/h8300/ChangeLog
===================================================================
--- cpukit/score/cpu/h8300/ChangeLog	(revision 4f0b287a4aa0d948d61f5c2ef1915c4db24f30e9)
+++ cpukit/score/cpu/h8300/ChangeLog	(revision 53f67279d744af9c810b5d4ba36575b09feb5e7f)
@@ -1,2 +1,10 @@
+2002-07-22	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: Use .$(OBJEXT) instead of .o.
+
+2002-07-22	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: Use . instead of .o.
+
 2002-07-05	Joel Sherrill <joel@OARcorp.com>
 
Index: cpukit/score/cpu/h8300/Makefile.am
===================================================================
--- cpukit/score/cpu/h8300/Makefile.am	(revision 4f0b287a4aa0d948d61f5c2ef1915c4db24f30e9)
+++ cpukit/score/cpu/h8300/Makefile.am	(revision 53f67279d744af9c810b5d4ba36575b09feb5e7f)
@@ -33,8 +33,8 @@
 
 C_FILES = cpu.c
-C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.o)
+C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.$(OBJEXT))
 
 S_FILES = cpu_asm.S
-S_O_FILES = $(S_FILES:%.S=$(ARCH)/%.o)
+S_O_FILES = $(S_FILES:%.S=$(ARCH)/%.$(OBJEXT))
 
 REL = $(ARCH)/rtems-cpu.rel
Index: cpukit/score/cpu/hppa1.1/ChangeLog
===================================================================
--- cpukit/score/cpu/hppa1.1/ChangeLog	(revision 4f0b287a4aa0d948d61f5c2ef1915c4db24f30e9)
+++ cpukit/score/cpu/hppa1.1/ChangeLog	(revision 53f67279d744af9c810b5d4ba36575b09feb5e7f)
@@ -1,2 +1,10 @@
+2002-07-22	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: Use .$(OBJEXT) instead of .o.
+
+2002-07-22	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: Use . instead of .o.
+
 2002-07-05	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
 
Index: cpukit/score/cpu/hppa1.1/Makefile.am
===================================================================
--- cpukit/score/cpu/hppa1.1/Makefile.am	(revision 4f0b287a4aa0d948d61f5c2ef1915c4db24f30e9)
+++ cpukit/score/cpu/hppa1.1/Makefile.am	(revision 53f67279d744af9c810b5d4ba36575b09feb5e7f)
@@ -35,8 +35,8 @@
 
 C_FILES = cpu.c
-C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.o)
+C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.$(OBJEXT))
 
 S_FILES = cpu_asm.S
-S_O_FILES = $(S_FILES:%.S=$(ARCH)/%.o)
+S_O_FILES = $(S_FILES:%.S=$(ARCH)/%.$(OBJEXT))
 
 REL = $(ARCH)/rtems-cpu.rel
Index: cpukit/score/cpu/i386/ChangeLog
===================================================================
--- cpukit/score/cpu/i386/ChangeLog	(revision 4f0b287a4aa0d948d61f5c2ef1915c4db24f30e9)
+++ cpukit/score/cpu/i386/ChangeLog	(revision 53f67279d744af9c810b5d4ba36575b09feb5e7f)
@@ -1,2 +1,10 @@
+2002-07-22	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: Use .$(OBJEXT) instead of .o.
+
+2002-07-22	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: Use . instead of .o.
+
 2002-07-05	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
 
Index: cpukit/score/cpu/i386/Makefile.am
===================================================================
--- cpukit/score/cpu/i386/Makefile.am	(revision 4f0b287a4aa0d948d61f5c2ef1915c4db24f30e9)
+++ cpukit/score/cpu/i386/Makefile.am	(revision 53f67279d744af9c810b5d4ba36575b09feb5e7f)
@@ -39,8 +39,8 @@
 
 C_FILES = cpu.c
-C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.o)
+C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.$(OBJEXT))
 
 S_FILES = cpu_asm.S
-S_O_FILES = $(S_FILES:%.S=$(ARCH)/%.o)
+S_O_FILES = $(S_FILES:%.S=$(ARCH)/%.$(OBJEXT))
 
 rtems_cpu_rel_OBJECTS = $(C_O_FILES) $(S_O_FILES)
Index: cpukit/score/cpu/i960/ChangeLog
===================================================================
--- cpukit/score/cpu/i960/ChangeLog	(revision 4f0b287a4aa0d948d61f5c2ef1915c4db24f30e9)
+++ cpukit/score/cpu/i960/ChangeLog	(revision 53f67279d744af9c810b5d4ba36575b09feb5e7f)
@@ -1,2 +1,6 @@
+2002-07-22	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: Use .$(OBJEXT) instead of .o.
+
 2002-07-05	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
 
Index: cpukit/score/cpu/i960/Makefile.am
===================================================================
--- cpukit/score/cpu/i960/Makefile.am	(revision 4f0b287a4aa0d948d61f5c2ef1915c4db24f30e9)
+++ cpukit/score/cpu/i960/Makefile.am	(revision 53f67279d744af9c810b5d4ba36575b09feb5e7f)
@@ -33,8 +33,8 @@
 
 C_FILES = cpu.c
-C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.o)
+C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.$(OBJEXT))
 
 S_FILES = cpu_asm.S
-S_O_FILES = $(S_FILES:%.S=$(ARCH)/%.o)
+S_O_FILES = $(S_FILES:%.S=$(ARCH)/%.$(OBJEXT))
 
 REL = $(ARCH)/rtems-cpu.rel
Index: cpukit/score/cpu/m68k/ChangeLog
===================================================================
--- cpukit/score/cpu/m68k/ChangeLog	(revision 4f0b287a4aa0d948d61f5c2ef1915c4db24f30e9)
+++ cpukit/score/cpu/m68k/ChangeLog	(revision 53f67279d744af9c810b5d4ba36575b09feb5e7f)
@@ -1,2 +1,6 @@
+2002-07-22	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: Use .$(OBJEXT) instead of .o.
+
 2002-07-05	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
 
Index: cpukit/score/cpu/m68k/Makefile.am
===================================================================
--- cpukit/score/cpu/m68k/Makefile.am	(revision 4f0b287a4aa0d948d61f5c2ef1915c4db24f30e9)
+++ cpukit/score/cpu/m68k/Makefile.am	(revision 53f67279d744af9c810b5d4ba36575b09feb5e7f)
@@ -33,8 +33,8 @@
 
 C_FILES = cpu.c memcpy.c
-C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.o)
+C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.$(OBJEXT))
 
 S_FILES = cpu_asm.S
-S_O_FILES = $(S_FILES:%.S=$(ARCH)/%.o)
+S_O_FILES = $(S_FILES:%.S=$(ARCH)/%.$(OBJEXT))
 
 REL = $(ARCH)/rtems-cpu.rel
Index: cpukit/score/cpu/mips/ChangeLog
===================================================================
--- cpukit/score/cpu/mips/ChangeLog	(revision 4f0b287a4aa0d948d61f5c2ef1915c4db24f30e9)
+++ cpukit/score/cpu/mips/ChangeLog	(revision 53f67279d744af9c810b5d4ba36575b09feb5e7f)
@@ -1,2 +1,6 @@
+2002-07-22	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: Use .$(OBJEXT) instead of .o.
+
 2002-07-16      Greg Menke <gregory.menke@gsfc.nasa.gov>
 
Index: cpukit/score/cpu/mips/Makefile.am
===================================================================
--- cpukit/score/cpu/mips/Makefile.am	(revision 4f0b287a4aa0d948d61f5c2ef1915c4db24f30e9)
+++ cpukit/score/cpu/mips/Makefile.am	(revision 53f67279d744af9c810b5d4ba36575b09feb5e7f)
@@ -33,8 +33,8 @@
 
 C_FILES = cpu.c
-C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.o)
+C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.$(OBJEXT))
 
 S_FILES = cpu_asm.S
-S_O_FILES = $(S_FILES:%.S=$(ARCH)/%.o)
+S_O_FILES = $(S_FILES:%.S=$(ARCH)/%.$(OBJEXT))
 
 REL = $(ARCH)/rtems-cpu.rel
Index: cpukit/score/cpu/mips64orion/ChangeLog
===================================================================
--- cpukit/score/cpu/mips64orion/ChangeLog	(revision 4f0b287a4aa0d948d61f5c2ef1915c4db24f30e9)
+++ cpukit/score/cpu/mips64orion/ChangeLog	(revision 53f67279d744af9c810b5d4ba36575b09feb5e7f)
@@ -1,2 +1,6 @@
+2002-07-22	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: Use .$(OBJEXT) instead of .o.
+
 2002-07-05	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
 
Index: cpukit/score/cpu/mips64orion/Makefile.am
===================================================================
--- cpukit/score/cpu/mips64orion/Makefile.am	(revision 4f0b287a4aa0d948d61f5c2ef1915c4db24f30e9)
+++ cpukit/score/cpu/mips64orion/Makefile.am	(revision 53f67279d744af9c810b5d4ba36575b09feb5e7f)
@@ -33,8 +33,8 @@
 
 C_FILES = cpu.c
-C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.o)
+C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.$(OBJEXT))
 
 S_FILES = cpu_asm.S
-S_O_FILES = $(S_FILES:%.S=$(ARCH)/%.o)
+S_O_FILES = $(S_FILES:%.S=$(ARCH)/%.$(OBJEXT))
 
 REL = $(ARCH)/rtems-cpu.rel
Index: cpukit/score/cpu/no_cpu/ChangeLog
===================================================================
--- cpukit/score/cpu/no_cpu/ChangeLog	(revision 4f0b287a4aa0d948d61f5c2ef1915c4db24f30e9)
+++ cpukit/score/cpu/no_cpu/ChangeLog	(revision 53f67279d744af9c810b5d4ba36575b09feb5e7f)
@@ -1,2 +1,6 @@
+2002-07-22	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: Use .$(OBJEXT) instead of .o.
+
 2002-07-05	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
 
Index: cpukit/score/cpu/no_cpu/Makefile.am
===================================================================
--- cpukit/score/cpu/no_cpu/Makefile.am	(revision 4f0b287a4aa0d948d61f5c2ef1915c4db24f30e9)
+++ cpukit/score/cpu/no_cpu/Makefile.am	(revision 53f67279d744af9c810b5d4ba36575b09feb5e7f)
@@ -34,5 +34,5 @@
 
 C_FILES = cpu.c cpu_asm.c
-C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.o)
+C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.$(OBJEXT))
 
 REL = $(ARCH)/rtems-cpu.rel
Index: cpukit/score/cpu/or16/ChangeLog
===================================================================
--- cpukit/score/cpu/or16/ChangeLog	(revision 4f0b287a4aa0d948d61f5c2ef1915c4db24f30e9)
+++ cpukit/score/cpu/or16/ChangeLog	(revision 53f67279d744af9c810b5d4ba36575b09feb5e7f)
@@ -1,2 +1,6 @@
+2002-07-22	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: Use .$(OBJEXT) instead of .o.
+
 2002-07-05	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
 
Index: cpukit/score/cpu/or16/Makefile.am
===================================================================
--- cpukit/score/cpu/or16/Makefile.am	(revision 4f0b287a4aa0d948d61f5c2ef1915c4db24f30e9)
+++ cpukit/score/cpu/or16/Makefile.am	(revision 53f67279d744af9c810b5d4ba36575b09feb5e7f)
@@ -34,5 +34,5 @@
 
 C_FILES = cpu.c cpu_asm.c
-C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.o)
+C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.$(OBJEXT))
 
 REL = $(ARCH)/rtems-cpu.rel
Index: cpukit/score/cpu/or32/ChangeLog
===================================================================
--- cpukit/score/cpu/or32/ChangeLog	(revision 4f0b287a4aa0d948d61f5c2ef1915c4db24f30e9)
+++ cpukit/score/cpu/or32/ChangeLog	(revision 53f67279d744af9c810b5d4ba36575b09feb5e7f)
@@ -1,2 +1,6 @@
+2002-07-22	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: Use .$(OBJEXT) instead of .o.
+
 2002-07-05	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
 
Index: cpukit/score/cpu/or32/Makefile.am
===================================================================
--- cpukit/score/cpu/or32/Makefile.am	(revision 4f0b287a4aa0d948d61f5c2ef1915c4db24f30e9)
+++ cpukit/score/cpu/or32/Makefile.am	(revision 53f67279d744af9c810b5d4ba36575b09feb5e7f)
@@ -34,5 +34,5 @@
 
 C_FILES = cpu.c cpu_asm.c
-C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.o)
+C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.$(OBJEXT))
 
 REL = $(ARCH)/rtems-cpu.rel
Index: cpukit/score/cpu/powerpc/ChangeLog
===================================================================
--- cpukit/score/cpu/powerpc/ChangeLog	(revision 4f0b287a4aa0d948d61f5c2ef1915c4db24f30e9)
+++ cpukit/score/cpu/powerpc/ChangeLog	(revision 53f67279d744af9c810b5d4ba36575b09feb5e7f)
@@ -1,2 +1,6 @@
+2002-07-22	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: Use .$(OBJEXT) instead of .o.
+
 2002-07-05	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
 
Index: cpukit/score/cpu/powerpc/Makefile.am
===================================================================
--- cpukit/score/cpu/powerpc/Makefile.am	(revision 4f0b287a4aa0d948d61f5c2ef1915c4db24f30e9)
+++ cpukit/score/cpu/powerpc/Makefile.am	(revision 53f67279d744af9c810b5d4ba36575b09feb5e7f)
@@ -62,5 +62,5 @@
     $(include_rtems_powerpc_HEADERS:%.h=$(PROJECT_INCLUDE)/%.h)
 
-# $(PROJECT_RELEASE)/lib$(MULTISUBDIR)/rtems$(LIB_VARIANT).o: $(ARCH)/rtems.o
+# $(PROJECT_RELEASE)/lib$(MULTISUBDIR)/rtems$(LIB_VARIANT).$(OBJEXT): $(ARCH)/rtems.$(OBJEXT)
 #	$(INSTALL_DATA) $< $@
 
@@ -69,5 +69,5 @@
 
 
-# TMPINSTALL_FILES += $(PROJECT_RELEASE)/lib$(MULTISUBDIR)/rtems$(LIB_VARIANT).o
+# TMPINSTALL_FILES += $(PROJECT_RELEASE)/lib$(MULTISUBDIR)/rtems$(LIB_VARIANT).$(OBJEXT)
 
 all-local: $(ARCH) $(PREINSTALL_FILES) $(rtems_cpu_rel_OBJECTS) $(REL) \
Index: cpukit/score/cpu/sh/ChangeLog
===================================================================
--- cpukit/score/cpu/sh/ChangeLog	(revision 4f0b287a4aa0d948d61f5c2ef1915c4db24f30e9)
+++ cpukit/score/cpu/sh/ChangeLog	(revision 53f67279d744af9c810b5d4ba36575b09feb5e7f)
@@ -1,2 +1,6 @@
+2002-07-22	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: Use .$(OBJEXT) instead of .o.
+
 2002-07-05	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
 
Index: cpukit/score/cpu/sh/Makefile.am
===================================================================
--- cpukit/score/cpu/sh/Makefile.am	(revision 4f0b287a4aa0d948d61f5c2ef1915c4db24f30e9)
+++ cpukit/score/cpu/sh/Makefile.am	(revision 53f67279d744af9c810b5d4ba36575b09feb5e7f)
@@ -34,5 +34,5 @@
 
 C_FILES = cpu.c
-C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.o)
+C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.$(OBJEXT))
 
 REL = $(ARCH)/rtems-cpu.rel
Index: cpukit/score/cpu/sparc/ChangeLog
===================================================================
--- cpukit/score/cpu/sparc/ChangeLog	(revision 4f0b287a4aa0d948d61f5c2ef1915c4db24f30e9)
+++ cpukit/score/cpu/sparc/ChangeLog	(revision 53f67279d744af9c810b5d4ba36575b09feb5e7f)
@@ -1,2 +1,6 @@
+2002-07-22	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: Use .$(OBJEXT) instead of .o.
+
 2002-07-05	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
 
Index: cpukit/score/cpu/sparc/Makefile.am
===================================================================
--- cpukit/score/cpu/sparc/Makefile.am	(revision 4f0b287a4aa0d948d61f5c2ef1915c4db24f30e9)
+++ cpukit/score/cpu/sparc/Makefile.am	(revision 53f67279d744af9c810b5d4ba36575b09feb5e7f)
@@ -33,8 +33,8 @@
 
 C_FILES = cpu.c
-C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.o)
+C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.$(OBJEXT))
 
 S_FILES = cpu_asm.S
-S_O_FILES = $(S_FILES:%.S=$(ARCH)/%.o)
+S_O_FILES = $(S_FILES:%.S=$(ARCH)/%.$(OBJEXT))
 
 REL = $(ARCH)/rtems-cpu.rel
Index: cpukit/score/cpu/unix/ChangeLog
===================================================================
--- cpukit/score/cpu/unix/ChangeLog	(revision 4f0b287a4aa0d948d61f5c2ef1915c4db24f30e9)
+++ cpukit/score/cpu/unix/ChangeLog	(revision 53f67279d744af9c810b5d4ba36575b09feb5e7f)
@@ -1,2 +1,6 @@
+2002-07-22	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: Use .$(OBJEXT) instead of .o.
+
 2002-07-05	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
 
Index: cpukit/score/cpu/unix/Makefile.am
===================================================================
--- cpukit/score/cpu/unix/Makefile.am	(revision 4f0b287a4aa0d948d61f5c2ef1915c4db24f30e9)
+++ cpukit/score/cpu/unix/Makefile.am	(revision 53f67279d744af9c810b5d4ba36575b09feb5e7f)
@@ -33,5 +33,5 @@
 
 C_FILES = cpu.c
-C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.o)
+C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.$(OBJEXT))
 
 REL = $(ARCH)/rtems-cpu.rel